Cannot block migrate in xenapi with iSCSI cinder volumes attached

Bug #1160323 reported by Bob Ball on 2013-03-26
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
OpenStack Compute (nova)
Medium
Bob Ball

Bug Description

Attempts to live migrate with cinder volumes attached give the following error, saying XAPI does not understand how to migrate the iSCSI VDI:

2013-03-26 11:43:14.317 ERROR nova.virt.xenapi.vmops [req-e611f9c5-b28c-4866-8ad5-9fdff535d1db admin demo] ['VDI_NOT_IN_MAP', 'bab415f3-62da-8bae-b80e-d3ce45a1ca5c']
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops Traceback (most recent call last):
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops File "/opt/stack/nova/nova/virt/xenapi/vmops.py", line 1722, in live_migrate
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops "VM.migrate_send", vm_ref, migrate_data)
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops File "/opt/stack/nova/nova/virt/xenapi/vmops.py", line 1709, in _call_live_migrate_command
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops vdi_map, vif_map, options)
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops File "/opt/stack/nova/nova/virt/xenapi/driver.py", line 726, in call_xenapi
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops return session.xenapi_request(method, args)
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops File "/usr/local/lib/python2.7/dist-packages/XenAPI.py", line 133, in xenapi_request
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops result = _parse_result(getattr(self, methodname)(*full_params))
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops File "/usr/local/lib/python2.7/dist-packages/XenAPI.py", line 203, in _parse_result
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops raise Failure(result['ErrorDescription'])
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops Failure: ['VDI_NOT_IN_MAP', 'bab415f3-62da-8bae-b80e-d3ce45a1ca5c']
2013-03-26 11:43:14.317 TRACE nova.virt.xenapi.vmops

Bob Ball (bob-ball) on 2013-03-26
tags: added: xenserver
Changed in nova:
status: New → In Progress
assignee: nobody → Bob Ball (bob-ball)
John Garbutt (johngarbutt) wrote :

thanks bob, I guess this needs an xcp fix/patch? and a nova patch?

Changed in nova:
importance: Undecided → Medium
Bob Ball (bob-ball) wrote :

Yes. I'm testing the combination at the moment then will post more details. This bug was raised now to give me a number to have a branch against(!)

Reviewed: https://review.openstack.org/25419
Committed: http://github.com/openstack/nova/commit/e507094eef9a7b4a54a04faade8aa95a36fa6d93
Submitter: Jenkins
Branch: master

commit e507094eef9a7b4a54a04faade8aa95a36fa6d93
Author: Bob Ball <email address hidden>
Date: Fri Mar 22 10:23:22 2013 +0000

    Enable live block migration when using iSCSI volumes

    Fix for bug 1160323.

    DocImpact
    Depends on a version of XAPI supporting relax-xsm-sr-check.
    Currently no release versions support this, so the change at
    https://github.com/xen-org/xen-api/pull/1116 would need to be applied
    to the source to enable this. XenServer 6.2 is expected to
    support this mode, and possibly some future hotfixes for XenServer 6.1.

    It also depends on a configuration change which must be documented and added to devstack:
    * Set "relax-xsm-sr-check = true" in /etc/xapi.conf

    This commit makes the following changes:
    * Attach the SR on the destination host prior to migrate
    * Returns the SR-ref from the pre_migrate call (API change)
    * Populates the XS VDI map with the sr-ref on the destination host
    * Removes the connection to the SR from the source host post-migrate
    * Added plugin to determine if iSCSI block migration is enabled

    Associated tempest test at https://review.openstack.org/#/c/26478/

    Change-Id: I917d9cf094190d636f4b9e14f6c8e728ff85af0e
    Fixes: bug 1160323

Changed in nova:
status: In Progress → Fix Committed
Thierry Carrez (ttx) on 2013-05-29
Changed in nova:
milestone: none → havana-1
status: Fix Committed → Fix Released
Thierry Carrez (ttx) on 2013-10-17
Changed in nova:
milestone: havana-1 → 2013.2
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers